Index: branches/2012/dev_MERGE_2012/NEMOGCM/NEMO/OPA_SRC/DYN/dynhpg.F90
===================================================================
--- branches/2012/dev_MERGE_2012/NEMOGCM/NEMO/OPA_SRC/DYN/dynhpg.F90	(revision 3759)
+++ branches/2012/dev_MERGE_2012/NEMOGCM/NEMO/OPA_SRC/DYN/dynhpg.F90	(revision 3764)
@@ -11,5 +11,5 @@
    !!            8.5  !  2002-08  (A. Bozec)  hpg_zps: Original code
    !!   NEMO     1.0  !  2005-10  (A. Beckmann, B.W. An)  various s-coordinate options
-   !!                 !         Original code for hpg_ctl, hpg_hel hpg_wdj, hpg_djc, hpg_rot 
+   !!                 !         Original code for hpg_ctl, hpg_hel hpg_wdj, hpg_djc, hpg_rot
    !!             -   !  2005-11  (G. Madec) style & small optimisation
    !!            3.3  !  2010-10  (C. Ethe, G. Madec) reorganisation of initialisation phase
@@ -31,9 +31,9 @@
    USE dom_oce         ! ocean space and time domain
    USE phycst          ! physical constants
-   USE trdmod          ! ocean dynamics trends 
+   USE trdmod          ! ocean dynamics trends
    USE trdmod_oce      ! ocean variables trends
    USE in_out_manager  ! I/O manager
    USE prtctl          ! Print control
-   USE lbclnk          ! lateral boundary condition 
+   USE lbclnk          ! lateral boundary condition
    USE lib_mpp         ! MPP library
    USE wrk_nemo        ! Memory Allocation
@@ -46,5 +46,5 @@
    PUBLIC   dyn_hpg_init   ! routine called by opa module
 
-   !                                              !!* Namelist namdyn_hpg : hydrostatic pressure gradient 
+   !                                              !!* Namelist namdyn_hpg : hydrostatic pressure gradient
    LOGICAL , PUBLIC ::   ln_hpg_zco    = .TRUE.    !: z-coordinate - full steps
    LOGICAL , PUBLIC ::   ln_hpg_zps    = .FALSE.   !: z-coordinate - partial steps (interpolation)
@@ -54,5 +54,5 @@
    LOGICAL , PUBLIC ::   ln_dynhpg_imp = .FALSE.   !: semi-implicite hpg flag
 
-   INTEGER  ::   nhpg  =  0   ! = 0 to 7, type of pressure gradient scheme used ! (deduced from ln_hpg_... flags)
+   INTEGER , PUBLIC ::   nhpg  =  0   ! = 0 to 7, type of pressure gradient scheme used ! (deduced from ln_hpg_... flags) (PUBLIC for TAM)
 
    !! * Substitutions
@@ -70,7 +70,7 @@
       !!                  ***  ROUTINE dyn_hpg  ***
       !!
-      !! ** Method  :   Call the hydrostatic pressure gradient routine 
+      !! ** Method  :   Call the hydrostatic pressure gradient routine
       !!              using the scheme defined in the namelist
-      !!   
+      !!
       !! ** Action : - Update (ua,va) with the now hydrastatic pressure trend
       !!             - Save the trend (l_trddyn=T)
@@ -84,7 +84,7 @@
       IF( l_trddyn ) THEN                    ! Temporary saving of ua and va trends (l_trddyn)
          CALL wrk_alloc( jpi,jpj,jpk, ztrdu, ztrdv )
-         ztrdu(:,:,:) = ua(:,:,:)  
-         ztrdv(:,:,:) = va(:,:,:) 
-      ENDIF      
+         ztrdu(:,:,:) = ua(:,:,:)
+         ztrdv(:,:,:) = va(:,:,:)
+      ENDIF
       !
       SELECT CASE ( nhpg )      ! Hydrostatic pressure gradient computation
@@ -101,5 +101,5 @@
          CALL trd_mod( ztrdu, ztrdv, jpdyn_trd_hpg, 'DYN', kt )
          CALL wrk_dealloc( jpi,jpj,jpk, ztrdu, ztrdv )
-      ENDIF          
+      ENDIF
       !
       IF(ln_ctl)   CALL prt_ctl( tab3d_1=ua, clinfo1=' hpg  - Ua: ', mask1=umask,   &
@@ -161,5 +161,5 @@
       !
       !                               ! Consistency check
-      ioptio = 0 
+      ioptio = 0
       IF( ln_hpg_zco )   ioptio = ioptio + 1
       IF( ln_hpg_zps )   ioptio = ioptio + 1
@@ -185,5 +185,5 @@
       !!            ua = ua - 1/e1u * zhpi
       !!            va = va - 1/e2v * zhpj
-      !! 
+      !!
       !! ** Action : - Update (ua,va) with the now hydrastatic pressure trend
       !!----------------------------------------------------------------------
@@ -192,7 +192,7 @@
       INTEGER  ::   ji, jj, jk       ! dummy loop indices
       REAL(wp) ::   zcoef0, zcoef1   ! temporary scalars
-      REAL(wp), POINTER, DIMENSION(:,:,:) ::  zhpi, zhpj 
-      !!----------------------------------------------------------------------
-      !  
+      REAL(wp), POINTER, DIMENSION(:,:,:) ::  zhpi, zhpj
+      !!----------------------------------------------------------------------
+      !
       CALL wrk_alloc( jpi,jpj,jpk, zhpi, zhpj )
       !
@@ -202,6 +202,6 @@
          IF(lwp) WRITE(numout,*) '~~~~~~~~~~~   z-coordinate case '
       ENDIF
-      
-      zcoef0 = - grav * 0.5_wp      ! Local constant initialization 
+
+      zcoef0 = - grav * 0.5_wp      ! Local constant initialization
 
       ! Surface value
@@ -247,9 +247,9 @@
       !!---------------------------------------------------------------------
       !!                 ***  ROUTINE hpg_zps  ***
-      !!                    
+      !!
       !! ** Method  :   z-coordinate plus partial steps case.  blahblah...
-      !! 
+      !!
       !! ** Action  : - Update (ua,va) with the now hydrastatic pressure trend
-      !!---------------------------------------------------------------------- 
+      !!----------------------------------------------------------------------
       INTEGER, INTENT(in) ::   kt    ! ocean time-step index
       !!
@@ -257,5 +257,5 @@
       INTEGER  ::   iku, ikv                         ! temporary integers
       REAL(wp) ::   zcoef0, zcoef1, zcoef2, zcoef3   ! temporary scalars
-      REAL(wp), POINTER, DIMENSION(:,:,:) ::  zhpi, zhpj 
+      REAL(wp), POINTER, DIMENSION(:,:,:) ::  zhpi, zhpj
       !!----------------------------------------------------------------------
       !
@@ -363,5 +363,5 @@
       INTEGER  ::   ji, jj, jk                 ! dummy loop indices
       REAL(wp) ::   zcoef0, zuap, zvap, znad   ! temporary scalars
-      REAL(wp), POINTER, DIMENSION(:,:,:) ::  zhpi, zhpj 
+      REAL(wp), POINTER, DIMENSION(:,:,:) ::  zhpi, zhpj
       !!----------------------------------------------------------------------
       !
@@ -383,5 +383,5 @@
       ! Surface value
       DO jj = 2, jpjm1
-         DO ji = fs_2, fs_jpim1   ! vector opt.   
+         DO ji = fs_2, fs_jpim1   ! vector opt.
             ! hydrostatic pressure gradient along s-surfaces
             zhpi(ji,jj,1) = zcoef0 / e1u(ji,jj) * ( fse3w(ji+1,jj  ,1) * ( znad + rhd(ji+1,jj  ,1) )   &
@@ -397,14 +397,14 @@
             ua(ji,jj,1) = ua(ji,jj,1) + zhpi(ji,jj,1) + zuap
             va(ji,jj,1) = va(ji,jj,1) + zhpj(ji,jj,1) + zvap
-         END DO  
-      END DO   
-            
+         END DO
+      END DO
+
       ! interior value (2=<jk=<jpkm1)
-      DO jk = 2, jpkm1                                  
-         DO jj = 2, jpjm1     
-            DO ji = fs_2, fs_jpim1   ! vector opt.      
+      DO jk = 2, jpkm1
+         DO jj = 2, jpjm1
+            DO ji = fs_2, fs_jpim1   ! vector opt.
                ! hydrostatic pressure gradient along s-surfaces
-               zhpi(ji,jj,jk) = zhpi(ji,jj,jk-1) + zcoef0 / e1u(ji,jj)   & 
-                  &           * (  fse3w(ji+1,jj,jk) * ( rhd(ji+1,jj,jk) + rhd(ji+1,jj,jk-1) + 2*znad )   & 
+               zhpi(ji,jj,jk) = zhpi(ji,jj,jk-1) + zcoef0 / e1u(ji,jj)   &
+                  &           * (  fse3w(ji+1,jj,jk) * ( rhd(ji+1,jj,jk) + rhd(ji+1,jj,jk-1) + 2*znad )   &
                   &              - fse3w(ji  ,jj,jk) * ( rhd(ji  ,jj,jk) + rhd(ji  ,jj,jk-1) + 2*znad )  )
                zhpj(ji,jj,jk) = zhpj(ji,jj,jk-1) + zcoef0 / e2v(ji,jj)   &
@@ -432,5 +432,5 @@
       !!
       !! ** Method  :   Density Jacobian with Cubic polynomial scheme
-      !! 
+      !!
       !! Reference: Shchepetkin and McWilliams, J. Geophys. Res., 108(C3), 3090, 2003
       !!----------------------------------------------------------------------
@@ -441,5 +441,5 @@
       REAL(wp) ::   z1_10, cffu, cffx   !    "         "
       REAL(wp) ::   z1_12, cffv, cffy   !    "         "
-      REAL(wp), POINTER, DIMENSION(:,:,:) ::  zhpi, zhpj 
+      REAL(wp), POINTER, DIMENSION(:,:,:) ::  zhpi, zhpj
       REAL(wp), POINTER, DIMENSION(:,:,:) ::  dzx, dzy, dzz, dzu, dzv, dzw
       REAL(wp), POINTER, DIMENSION(:,:,:) ::  drhox, drhoy, drhoz, drhou, drhov, drhow
@@ -447,7 +447,7 @@
       !!----------------------------------------------------------------------
       !
-      CALL wrk_alloc( jpi, jpj, jpk, dzx  , dzy  , dzz  , dzu  , dzv  , dzw   ) 
-      CALL wrk_alloc( jpi, jpj, jpk, drhox, drhoy, drhoz, drhou, drhov, drhow ) 
-      CALL wrk_alloc( jpi, jpj, jpk, rho_i, rho_j, rho_k,  zhpi,  zhpj        ) 
+      CALL wrk_alloc( jpi, jpj, jpk, dzx  , dzy  , dzz  , dzu  , dzv  , dzw   )
+      CALL wrk_alloc( jpi, jpj, jpk, drhox, drhoy, drhoz, drhou, drhov, drhow )
+      CALL wrk_alloc( jpi, jpj, jpk, rho_i, rho_j, rho_k,  zhpi,  zhpj        )
       !
 
@@ -497,5 +497,5 @@
                cffu = 2._wp * drhox(ji+1,jj  ,jk) * drhox(ji,jj,jk  )
                cffx = 2._wp * dzx  (ji+1,jj  ,jk) * dzx  (ji,jj,jk  )
-  
+
                cffv = 2._wp * drhoy(ji  ,jj+1,jk) * drhoy(ji,jj,jk  )
                cffy = 2._wp * dzy  (ji  ,jj+1,jk) * dzy  (ji,jj,jk  )
@@ -568,5 +568,5 @@
                &                     + 0.5_wp * ( rhd(ji,jj,2) - rhd(ji,jj,1) )         &
                &                              * ( fse3w (ji,jj,1) - fsde3w(ji,jj,1) )   &
-               &                              / ( fsde3w(ji,jj,2) - fsde3w(ji,jj,1) )  ) 
+               &                              / ( fsde3w(ji,jj,2) - fsde3w(ji,jj,1) )  )
          END DO
       END DO
@@ -631,5 +631,5 @@
       ! ----------------
       DO jk = 2, jpkm1
-         DO jj = 2, jpjm1 
+         DO jj = 2, jpjm1
             DO ji = fs_2, fs_jpim1   ! vector opt.
                ! hydrostatic pressure gradient along s-surfaces
@@ -647,7 +647,7 @@
       END DO
       !
-      CALL wrk_dealloc( jpi, jpj, jpk, dzx  , dzy  , dzz  , dzu  , dzv  , dzw   ) 
-      CALL wrk_dealloc( jpi, jpj, jpk, drhox, drhoy, drhoz, drhou, drhov, drhow ) 
-      CALL wrk_dealloc( jpi, jpj, jpk, rho_i, rho_j, rho_k,  zhpi,  zhpj        ) 
+      CALL wrk_dealloc( jpi, jpj, jpk, dzx  , dzy  , dzz  , dzu  , dzv  , dzw   )
+      CALL wrk_dealloc( jpi, jpj, jpk, drhox, drhoy, drhoz, drhou, drhov, drhow )
+      CALL wrk_dealloc( jpi, jpj, jpk, rho_i, rho_j, rho_k,  zhpi,  zhpj        )
       !
    END SUBROUTINE hpg_djc
@@ -676,12 +676,12 @@
       INTEGER  :: jk1, jis, jid, jjs, jjd
       REAL(wp) :: zuijk, zvijk, zpwes, zpwed, zpnss, zpnsd, zdeps
-      REAL(wp) :: zrhdt1 
+      REAL(wp) :: zrhdt1
       REAL(wp) :: zdpdx1, zdpdx2, zdpdy1, zdpdy2
-      REAL(wp), POINTER, DIMENSION(:,:,:) ::   zdept, zrhh 
+      REAL(wp), POINTER, DIMENSION(:,:,:) ::   zdept, zrhh
       REAL(wp), POINTER, DIMENSION(:,:,:) ::   zhpi, zu, zv, fsp, xsp, asp, bsp, csp, dsp
       !!----------------------------------------------------------------------
       !
-      CALL wrk_alloc( jpi,jpj,jpk, zhpi, zu, zv, fsp, xsp, asp, bsp, csp, dsp ) 
-      CALL wrk_alloc( jpi,jpj,jpk, zdept, zrhh ) 
+      CALL wrk_alloc( jpi,jpj,jpk, zhpi, zu, zv, fsp, xsp, asp, bsp, csp, dsp )
+      CALL wrk_alloc( jpi,jpj,jpk, zdept, zrhh )
       !
       IF( kt == nit000 ) THEN
@@ -693,5 +693,5 @@
       !!----------------------------------------------------------------------
       ! Local constant initialization
-      zcoef0 = - grav 
+      zcoef0 = - grav
       znad = 0.0_wp
       IF( lk_vvl ) znad = 1._wp
@@ -700,8 +700,8 @@
       zhpi(:,:,:) = 0._wp
       zrhh(:,:,:) = rhd(:,:,:)
-      
+
       ! Preparing vertical density profile "zrhh(:,:,:)" for hybrid-sco coordinate
       DO jj = 1, jpj
-        DO ji = 1, jpi   
+        DO ji = 1, jpi
           jk = mbathy(ji,jj)
           IF( jk <= 0 ) THEN; zrhh(ji,jj,:) = 0._wp
@@ -711,5 +711,5 @@
                 zrhh(ji,jj,jkk) = interp1(fsde3w(ji,jj,jkk),   fsde3w(ji,jj,jkk-1), &
                                          fsde3w(ji,jj,jkk-2), rhd(ji,jj,jkk-1), rhd(ji,jj,jkk-2))
-             END DO 
+             END DO
           ENDIF
         END DO
@@ -728,12 +728,12 @@
       xsp(:,:,:) = zdept(:,:,:)
 
-      ! Construct the vertical density profile with the 
+      ! Construct the vertical density profile with the
       ! constrained cubic spline interpolation
       ! rho(z) = asp + bsp*z + csp*z^2 + dsp*z^3
-      CALL cspline(fsp,xsp,asp,bsp,csp,dsp,polynomial_type)      
+      CALL cspline(fsp,xsp,asp,bsp,csp,dsp,polynomial_type)
 
       ! Integrate the hydrostatic pressure "zhpi(:,:,:)" at "T(ji,jj,1)"
       DO jj = 2, jpj
-        DO ji = 2, jpi 
+        DO ji = 2, jpi
           zrhdt1 = zrhh(ji,jj,1) - interp3(zdept(ji,jj,1),asp(ji,jj,1), &
                                          bsp(ji,jj,1),   csp(ji,jj,1), &
@@ -741,11 +741,11 @@
 
           ! assuming linear profile across the top half surface layer
-          zhpi(ji,jj,1) =  0.5_wp * fse3w(ji,jj,1) * zrhdt1  
+          zhpi(ji,jj,1) =  0.5_wp * fse3w(ji,jj,1) * zrhdt1
         END DO
       END DO
 
       ! Calculate the pressure "zhpi(:,:,:)" at "T(ji,jj,2:jpkm1)"
-      DO jk = 2, jpkm1                                  
-        DO jj = 2, jpj     
+      DO jk = 2, jpkm1
+        DO jj = 2, jpj
           DO ji = 2, jpi
             zhpi(ji,jj,jk) = zhpi(ji,jj,jk-1) +                          &
@@ -758,6 +758,6 @@
 
       ! Z coordinate of U(ji,jj,1:jpkm1) and V(ji,jj,1:jpkm1)
-      DO jj = 2, jpjm1     
-        DO ji = 2, jpim1  
+      DO jj = 2, jpjm1
+        DO ji = 2, jpim1
           zu(ji,jj,1) = - ( fse3u(ji,jj,1) - sshu_n(ji,jj) * znad)
           zv(ji,jj,1) = - ( fse3v(ji,jj,1) - sshv_n(ji,jj) * znad)
@@ -765,7 +765,7 @@
       END DO
 
-      DO jk = 2, jpkm1                                  
-        DO jj = 2, jpjm1     
-          DO ji = 2, jpim1  
+      DO jk = 2, jpkm1
+        DO jj = 2, jpjm1
+          DO ji = 2, jpim1
             zu(ji,jj,jk) = zu(ji,jj,jk-1)- fse3u(ji,jj,jk)
             zv(ji,jj,jk) = zv(ji,jj,jk-1)- fse3v(ji,jj,jk)
@@ -773,8 +773,8 @@
         END DO
       END DO
-               
-      DO jk = 1, jpkm1                                  
-        DO jj = 2, jpjm1     
-          DO ji = 2, jpim1  
+
+      DO jk = 1, jpkm1
+        DO jj = 2, jpjm1
+          DO ji = 2, jpim1
             zu(ji,jj,jk) = zu(ji,jj,jk) + 0.5_wp * fse3u(ji,jj,jk)
             zv(ji,jj,jk) = zv(ji,jj,jk) + 0.5_wp * fse3v(ji,jj,jk)
@@ -795,7 +795,7 @@
 
 
-      DO jk = 1, jpkm1                                  
-        DO jj = 2, jpjm1     
-          DO ji = 2, jpim1  
+      DO jk = 1, jpkm1
+        DO jj = 2, jpjm1
+          DO ji = 2, jpim1
             zpwes = 0._wp; zpwed = 0._wp
             zpnss = 0._wp; zpnsd = 0._wp
@@ -812,5 +812,5 @@
 
                ! integrate the pressure on the shallow side
-               jk1 = jk 
+               jk1 = jk
                DO WHILE ( -zdept(jis,jj,jk1) > zuijk )
                  IF( jk1 == mbku(ji,jj) ) THEN
@@ -819,5 +819,5 @@
                  ENDIF
                  zdeps = MIN(zdept(jis,jj,jk1+1), -zuijk)
-                 zpwes = zpwes +                                    & 
+                 zpwes = zpwes +                                    &
                       integ_spline(zdept(jis,jj,jk1), zdeps,            &
                              asp(jis,jj,jk1),    bsp(jis,jj,jk1), &
@@ -825,7 +825,7 @@
                  jk1 = jk1 + 1
                END DO
-            
+
                ! integrate the pressure on the deep side
-               jk1 = jk 
+               jk1 = jk
                DO WHILE ( -zdept(jid,jj,jk1) < zuijk )
                  IF( jk1 == 1 ) THEN
@@ -838,5 +838,5 @@
                  ENDIF
                  zdeps = MAX(zdept(jid,jj,jk1-1), -zuijk)
-                 zpwed = zpwed +                                        & 
+                 zpwed = zpwed +                                        &
                         integ_spline(zdeps,              zdept(jid,jj,jk1), &
                                asp(jid,jj,jk1-1), bsp(jid,jj,jk1-1),  &
@@ -844,13 +844,13 @@
                  jk1 = jk1 - 1
                END DO
-            
+
                ! update the momentum trends in u direction
 
                zdpdx1 = zcoef0 / e1u(ji,jj) * (zhpi(ji+1,jj,jk) - zhpi(ji,jj,jk))
                IF( lk_vvl ) THEN
-                 zdpdx2 = zcoef0 / e1u(ji,jj) * & 
-                         ( REAL(jis-jid, wp) * (zpwes + zpwed) + (sshn(ji+1,jj)-sshn(ji,jj)) ) 
+                 zdpdx2 = zcoef0 / e1u(ji,jj) * &
+                         ( REAL(jis-jid, wp) * (zpwes + zpwed) + (sshn(ji+1,jj)-sshn(ji,jj)) )
                 ELSE
-                 zdpdx2 = zcoef0 / e1u(ji,jj) * REAL(jis-jid, wp) * (zpwes + zpwed) 
+                 zdpdx2 = zcoef0 / e1u(ji,jj) * REAL(jis-jid, wp) * (zpwes + zpwed)
                ENDIF
 
@@ -858,5 +858,5 @@
                &           umask(ji,jj,jk) * tmask(ji,jj,jk) * tmask(ji+1,jj,jk)
             ENDIF
-  
+
             !!!!!     for v equation
             IF( jk <= mbkv(ji,jj) ) THEN
@@ -868,5 +868,5 @@
 
                ! integrate the pressure on the shallow side
-               jk1 = jk 
+               jk1 = jk
                DO WHILE ( -zdept(ji,jjs,jk1) > zvijk )
                  IF( jk1 == mbkv(ji,jj) ) THEN
@@ -875,5 +875,5 @@
                  ENDIF
                  zdeps = MIN(zdept(ji,jjs,jk1+1), -zvijk)
-                 zpnss = zpnss +                                      & 
+                 zpnss = zpnss +                                      &
                         integ_spline(zdept(ji,jjs,jk1), zdeps,            &
                                asp(ji,jjs,jk1),    bsp(ji,jjs,jk1), &
@@ -881,7 +881,7 @@
                  jk1 = jk1 + 1
                END DO
-            
+
                ! integrate the pressure on the deep side
-               jk1 = jk 
+               jk1 = jk
                DO WHILE ( -zdept(ji,jjd,jk1) < zvijk )
                  IF( jk1 == 1 ) THEN
@@ -894,5 +894,5 @@
                  ENDIF
                  zdeps = MAX(zdept(ji,jjd,jk1-1), -zvijk)
-                 zpnsd = zpnsd +                                        & 
+                 zpnsd = zpnsd +                                        &
                         integ_spline(zdeps,              zdept(ji,jjd,jk1), &
                                asp(ji,jjd,jk1-1), bsp(ji,jjd,jk1-1), &
@@ -900,5 +900,5 @@
                  jk1 = jk1 - 1
                END DO
-            
+
 
                ! update the momentum trends in v direction
@@ -907,7 +907,7 @@
                IF( lk_vvl ) THEN
                    zdpdy2 = zcoef0 / e2v(ji,jj) * &
-                           ( REAL(jjs-jjd, wp) * (zpnss + zpnsd) + (sshn(ji,jj+1)-sshn(ji,jj)) ) 
+                           ( REAL(jjs-jjd, wp) * (zpnss + zpnsd) + (sshn(ji,jj+1)-sshn(ji,jj)) )
                ELSE
-                   zdpdy2 = zcoef0 / e2v(ji,jj) * REAL(jjs-jjd, wp) * (zpnss + zpnsd ) 
+                   zdpdy2 = zcoef0 / e2v(ji,jj) * REAL(jjs-jjd, wp) * (zpnss + zpnsd )
                ENDIF
 
@@ -916,11 +916,11 @@
             ENDIF
 
-                    
+
            END DO
         END DO
       END DO
       !
-      CALL wrk_dealloc( jpi,jpj,jpk, zhpi, zu, zv, fsp, xsp, asp, bsp, csp, dsp ) 
-      CALL wrk_dealloc( jpi,jpj,jpk, zdept, zrhh ) 
+      CALL wrk_dealloc( jpi,jpj,jpk, zhpi, zu, zv, fsp, xsp, asp, bsp, csp, dsp )
+      CALL wrk_dealloc( jpi,jpj,jpk, zdept, zrhh )
       !
    END SUBROUTINE hpg_prj
@@ -929,8 +929,8 @@
       !!----------------------------------------------------------------------
       !!                 ***  ROUTINE cspline  ***
-      !!       
+      !!
       !! ** Purpose :   constrained cubic spline interpolation
-      !!          
-      !! ** Method  :   f(x) = asp + bsp*x + csp*x^2 + dsp*x^3 
+      !!
+      !! ** Method  :   f(x) = asp + bsp*x + csp*x^2 + dsp*x^3
       !! Reference: CJC Kruger, Constrained Cubic Spline Interpoltation
       !!
@@ -938,10 +938,10 @@
       IMPLICIT NONE
       REAL(wp), DIMENSION(:,:,:), INTENT(in)  :: fsp, xsp           ! value and coordinate
-      REAL(wp), DIMENSION(:,:,:), INTENT(out) :: asp, bsp, csp, dsp ! coefficients of 
+      REAL(wp), DIMENSION(:,:,:), INTENT(out) :: asp, bsp, csp, dsp ! coefficients of
                                                                     ! the interpoated function
-      INTEGER, INTENT(in) :: polynomial_type                        ! 1: cubic spline 
+      INTEGER, INTENT(in) :: polynomial_type                        ! 1: cubic spline
                                                                     ! 2: Linear
 
-      ! Local Variables      
+      ! Local Variables
       INTEGER  ::   ji, jj, jk                 ! dummy loop indices
       INTEGER  ::   jpi, jpj, jpkm1
@@ -955,17 +955,17 @@
       jpkm1 = size(fsp,3) - 1
 
-      
+
       IF (polynomial_type == 1) THEN     ! Constrained Cubic Spline
          DO ji = 1, jpi
             DO jj = 1, jpj
-           !!Fritsch&Butland's method, 1984 (preferred, but more computation)              
+           !!Fritsch&Butland's method, 1984 (preferred, but more computation)
            !    DO jk = 2, jpkm1-1
-           !       zdxtmp1 = xsp(ji,jj,jk)   - xsp(ji,jj,jk-1)  
-           !       zdxtmp2 = xsp(ji,jj,jk+1) - xsp(ji,jj,jk)  
+           !       zdxtmp1 = xsp(ji,jj,jk)   - xsp(ji,jj,jk-1)
+           !       zdxtmp2 = xsp(ji,jj,jk+1) - xsp(ji,jj,jk)
            !       zdf1    = ( fsp(ji,jj,jk)   - fsp(ji,jj,jk-1) ) / zdxtmp1
            !       zdf2    = ( fsp(ji,jj,jk+1) - fsp(ji,jj,jk)   ) / zdxtmp2
            !
            !       zalpha = ( zdxtmp1 + 2._wp * zdxtmp2 ) / ( zdxtmp1 + zdxtmp2 ) / 3._wp
-           !     
+           !
            !       IF(zdf1 * zdf2 <= 0._wp) THEN
            !           zdf(jk) = 0._wp
@@ -974,10 +974,10 @@
            !       ENDIF
            !    END DO
-           
+
            !!Simply geometric average
                DO jk = 2, jpkm1-1
                   zdf1 = (fsp(ji,jj,jk) - fsp(ji,jj,jk-1)) / (xsp(ji,jj,jk) - xsp(ji,jj,jk-1))
                   zdf2 = (fsp(ji,jj,jk+1) - fsp(ji,jj,jk)) / (xsp(ji,jj,jk+1) - xsp(ji,jj,jk))
-            
+
                   IF(zdf1 * zdf2 <= 0._wp) THEN
                      zdf(jk) = 0._wp
@@ -986,5 +986,5 @@
                   ENDIF
                END DO
-           
+
                zdf(1)     = 1.5_wp * ( fsp(ji,jj,2) - fsp(ji,jj,1) ) / &
                           &          ( xsp(ji,jj,2) - xsp(ji,jj,1) ) -  0.5_wp * zdf(2)
@@ -992,16 +992,16 @@
                           &          ( xsp(ji,jj,jpkm1) - xsp(ji,jj,jpkm1-1) ) - &
                           & 0.5_wp * zdf(jpkm1 - 1)
-   
+
                DO jk = 1, jpkm1 - 1
-                 zdxtmp = xsp(ji,jj,jk+1) - xsp(ji,jj,jk) 
+                 zdxtmp = xsp(ji,jj,jk+1) - xsp(ji,jj,jk)
                  ztmp1  = (zdf(jk+1) + 2._wp * zdf(jk)) / zdxtmp
                  ztmp2  =  6._wp * (fsp(ji,jj,jk+1) - fsp(ji,jj,jk)) / zdxtmp / zdxtmp
-                 zddf1  = -2._wp * ztmp1 + ztmp2 
+                 zddf1  = -2._wp * ztmp1 + ztmp2
                  ztmp1  = (2._wp * zdf(jk+1) + zdf(jk)) / zdxtmp
-                 zddf2  =  2._wp * ztmp1 - ztmp2 
-      
+                 zddf2  =  2._wp * ztmp1 - ztmp2
+
                  dsp(ji,jj,jk) = (zddf2 - zddf1) / 6._wp / zdxtmp
                  csp(ji,jj,jk) = ( xsp(ji,jj,jk+1) * zddf1 - xsp(ji,jj,jk)*zddf2 ) / 2._wp / zdxtmp
-                 bsp(ji,jj,jk) = ( fsp(ji,jj,jk+1) - fsp(ji,jj,jk) ) / zdxtmp - & 
+                 bsp(ji,jj,jk) = ( fsp(ji,jj,jk+1) - fsp(ji,jj,jk) ) / zdxtmp - &
                                & csp(ji,jj,jk) * ( xsp(ji,jj,jk+1) + xsp(ji,jj,jk) ) - &
                                & dsp(ji,jj,jk) * ((xsp(ji,jj,jk+1) + xsp(ji,jj,jk))**2 - &
@@ -1013,12 +1013,12 @@
             END DO
          END DO
- 
+
       ELSE IF (polynomial_type == 2) THEN     ! Linear
          DO ji = 1, jpi
             DO jj = 1, jpj
                DO jk = 1, jpkm1-1
-                  zdxtmp =xsp(ji,jj,jk+1) - xsp(ji,jj,jk) 
+                  zdxtmp =xsp(ji,jj,jk+1) - xsp(ji,jj,jk)
                   ztmp1 = fsp(ji,jj,jk+1) - fsp(ji,jj,jk)
-   
+
                   dsp(ji,jj,jk) = 0._wp
                   csp(ji,jj,jk) = 0._wp
@@ -1033,21 +1033,21 @@
       ENDIF
 
-      
+
    END SUBROUTINE cspline
 
 
-   FUNCTION interp1(x, xl, xr, fl, fr)  RESULT(f) 
+   FUNCTION interp1(x, xl, xr, fl, fr)  RESULT(f)
       !!----------------------------------------------------------------------
       !!                 ***  ROUTINE interp1  ***
-      !!       
+      !!
       !! ** Purpose :   1-d linear interpolation
-      !!          
-      !! ** Method  :  
+      !!
+      !! ** Method  :
       !!                interpolation is straight forward
-      !!                extrapolation is also permitted (no value limit) 
+      !!                extrapolation is also permitted (no value limit)
       !!
       !!----------------------------------------------------------------------
       IMPLICIT NONE
-      REAL(wp), INTENT(in) ::  x, xl, xr, fl, fr   
+      REAL(wp), INTENT(in) ::  x, xl, xr, fl, fr
       REAL(wp)             ::  f ! result of the interpolation (extrapolation)
       REAL(wp)             ::  zdeltx
@@ -1060,38 +1060,38 @@
         f = ( (x - xl ) * fr - ( x - xr ) * fl ) / zdeltx
       ENDIF
-      
+
    END FUNCTION interp1
 
-   FUNCTION interp2(x, a, b, c, d)  RESULT(f) 
+   FUNCTION interp2(x, a, b, c, d)  RESULT(f)
       !!----------------------------------------------------------------------
       !!                 ***  ROUTINE interp1  ***
-      !!       
+      !!
       !! ** Purpose :   1-d constrained cubic spline interpolation
-      !!          
+      !!
       !! ** Method  :  cubic spline interpolation
       !!
       !!----------------------------------------------------------------------
       IMPLICIT NONE
-      REAL(wp), INTENT(in) ::  x, a, b, c, d   
+      REAL(wp), INTENT(in) ::  x, a, b, c, d
       REAL(wp)             ::  f ! value from the interpolation
       !!----------------------------------------------------------------------
 
-      f = a + x* ( b + x * ( c + d * x ) ) 
+      f = a + x* ( b + x * ( c + d * x ) )
 
    END FUNCTION interp2
 
 
-   FUNCTION interp3(x, a, b, c, d)  RESULT(f) 
+   FUNCTION interp3(x, a, b, c, d)  RESULT(f)
       !!----------------------------------------------------------------------
       !!                 ***  ROUTINE interp1  ***
-      !!       
+      !!
       !! ** Purpose :   Calculate the first order of deriavtive of
       !!                a cubic spline function y=a+b*x+c*x^2+d*x^3
-      !!          
+      !!
       !! ** Method  :   f=dy/dx=b+2*c*x+3*d*x^2
       !!
       !!----------------------------------------------------------------------
       IMPLICIT NONE
-      REAL(wp), INTENT(in) ::  x, a, b, c, d   
+      REAL(wp), INTENT(in) ::  x, a, b, c, d
       REAL(wp)             ::  f ! value from the interpolation
       !!----------------------------------------------------------------------
@@ -1101,23 +1101,23 @@
    END FUNCTION interp3
 
-   
-   FUNCTION integ_spline(xl, xr, a, b, c, d)  RESULT(f) 
+
+   FUNCTION integ_spline(xl, xr, a, b, c, d)  RESULT(f)
       !!----------------------------------------------------------------------
       !!                 ***  ROUTINE interp1  ***
-      !!       
+      !!
       !! ** Purpose :   1-d constrained cubic spline integration
-      !!          
-      !! ** Method  :  integrate polynomial a+bx+cx^2+dx^3 from xl to xr 
+      !!
+      !! ** Method  :  integrate polynomial a+bx+cx^2+dx^3 from xl to xr
       !!
       !!----------------------------------------------------------------------
       IMPLICIT NONE
-      REAL(wp), INTENT(in) ::  xl, xr, a, b, c, d   
-      REAL(wp)             ::  za1, za2, za3      
+      REAL(wp), INTENT(in) ::  xl, xr, a, b, c, d
+      REAL(wp)             ::  za1, za2, za3
       REAL(wp)             ::  f                   ! integration result
       !!----------------------------------------------------------------------
 
-      za1 = 0.5_wp * b 
-      za2 = c / 3.0_wp 
-      za3 = 0.25_wp * d 
+      za1 = 0.5_wp * b
+      za2 = c / 3.0_wp
+      za3 = 0.25_wp * d
 
       f  = xr * ( a + xr * ( za1 + xr * ( za2 + za3 * xr ) ) ) - &
Index: branches/2012/dev_MERGE_2012/NEMOGCM/NEMO/OPA_SRC/DYN/dynnxt.F90
===================================================================
--- branches/2012/dev_MERGE_2012/NEMOGCM/NEMO/OPA_SRC/DYN/dynnxt.F90	(revision 3759)
+++ branches/2012/dev_MERGE_2012/NEMOGCM/NEMO/OPA_SRC/DYN/dynnxt.F90	(revision 3764)
@@ -156,5 +156,5 @@
 # if defined key_obc
       !                                !* OBC open boundaries
-      CALL obc_dyn( kt )
+      IF( lk_obc ) CALL obc_dyn( kt )
       !
       IF( .NOT. lk_dynspg_flt ) THEN
@@ -163,10 +163,10 @@
          !                                       sshn_b (= after ssha_b) for time-splitting case (lk_dynspg_ts=T)
          !                              - Correct the barotropic velocities
-         CALL obc_dyn_bt( kt )
+         IF( lk_obc ) CALL obc_dyn_bt( kt )
          !
 !!gm ERROR - potential BUG: sshn should not be modified at this stage !!   ssh_nxt not alrady called
          CALL lbc_lnk( sshn, 'T', 1. )         ! Boundary conditions on sshn
          !
-         IF( ln_vol_cst )   CALL obc_vol( kt )
+         IF( lk_obc .AND. ln_vol_cst )   CALL obc_vol( kt )
          !
          IF(ln_ctl)   CALL prt_ctl( tab2d_1=sshn, clinfo1=' ssh      : ', mask1=tmask )
@@ -175,6 +175,6 @@
 # elif defined key_bdy
       !                                !* BDY open boundaries
-      IF( lk_dynspg_exp ) CALL bdy_dyn( kt )
-      IF( lk_dynspg_ts )  CALL bdy_dyn( kt, dyn3d_only=.true. )
+      IF( lk_bdy .AND. lk_dynspg_exp ) CALL bdy_dyn( kt )
+      IF( lk_bdy .AND. lk_dynspg_ts  ) CALL bdy_dyn( kt, dyn3d_only=.true. )
 
 !!$   Do we need a call to bdy_vol here??
@@ -248,5 +248,5 @@
                DO jk = 1, jpkm1                       ! Leap-Frog - Asselin filter and swap: 
                   DO jj = 1, jpj                      !                   applied on thickness weighted velocity
-                     DO ji = 1, jpim1                 !                              ---------------------------
+                     DO ji = 1, jpi                   !                              ---------------------------
                         zue3a = ua(ji,jj,jk) * fse3u_a(ji,jj,jk)
                         zve3a = va(ji,jj,jk) * fse3v_a(ji,jj,jk)
@@ -268,6 +268,4 @@
                fse3u_b(:,:,1:jpkm1) = ze3u_f(:,:,1:jpkm1)      ! e3u_b <-- filtered scale factor
                fse3v_b(:,:,1:jpkm1) = ze3v_f(:,:,1:jpkm1)
-               CALL lbc_lnk( ub, 'U', -1. )                    ! lateral boundary conditions
-               CALL lbc_lnk( vb, 'V', -1. )
             ENDIF
             !
